////////////////////////////////////////////////////////////////////////////////
// Main Class File:  FireworksApp.java
// File:             LineParticle.java
// Semester:         Spring 2008
//
// Author:           Tim Bahls
// CS Login:         bahls
// Lecturer:         self
//////////////////////////// 80 columns wide ///////////////////////////////////


import java.awt.Graphics;

/**
 * This particle is drawn as a line.
 * 
 * @author Tim
 * 
 */
public class LineParticle extends Particle {

	// relative length of line
	private double lineScale;

	/**
	 * Constructor that lets you determine color, line length and start
	 * position.
	 * 
	 * @param hue
	 *            A number from 0 to 1 that specifies desired hue of the
	 *            Particle
	 * @param startX
	 *            The starting x coordinate
	 * @param startY
	 *            The starting y coordinate
	 * @param length
	 *            The length of the line to draw, in pixels.
	 */
	public LineParticle(double hue, double startX, double startY, double length) {
		super(hue, startX, startY);
		lineScale = length;
	}

	/**
	 * Draw this Particle onto the provided Graphics object
	 * 
	 * @param graphics
	 *            The Graphics object to draw onto.
	 */
	public void drawSelf(Graphics graphics) {
		// Set the color to the Color of this Particle
		graphics.setColor(getColor());

		// find the coordinates for drawing the line. Notice that faster
		// Particles make longer lines.
		double startX = getXPosition();
		double startY = getYPosition();
		double endX = startX + getXVelocity() * lineScale;
		double endY = startY + getYVelocity() * lineScale;

		// draw the line
		graphics.drawLine((int) startX, (int) startY, (int) endX, (int) endY);
	}

}
